﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Threading.Tasks;
using HarmonyLib;
using I2.Loc;
using System;
using System.Reflection;


using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using Steamworks;
using FMOD.Studio;
using TMPro;
using UnityEngine.UI;
using UnityEngine.AzureSky;
using System.Threading;
using System.Timers;

namespace Arashi
{
    //==============================================================================================================================================
    //----------------------------------------------------------Arashi's Fishing Expansion---------------------------------------------------------
    //==============================================================================================================================================

    public class Arashi_RaftFishingExpansion : Mod
    {
        //Constants
        RBlockQuadType[] StandardQuadType = new RBlockQuadType[] { RBlockQuadType.quad_floor, RBlockQuadType.quad_foundation, RBlockQuadType.quad_table };
        RBlockQuadType[] FoundationQuadType = new RBlockQuadType[] { RBlockQuadType.quad_foundation_empty };
        RBlockQuadType[] TableQuadType = new RBlockQuadType[] { RBlockQuadType.quad_table };
        Harmony harmonyInstance;
        string harmonyID = "com.arashi.fishingexpansion";

        //Asset Files
        public static AssetBundle ScrapMechanicTrophies, Arashi_FishingNets, Chapter2HotFix, FishingNetHotFix;

        //Audio Bank
        public static List<AudioClip> sound_FX = new List<AudioClip>();
        public static List<AudioClip> music = new List<AudioClip>();

        //Graphics Storage
        public static List<GameObject> particles = new List<GameObject>();

        //Game Objects
        //public static List<GameObject> object_3D = new List<GameObject>();
        // public static List<Sprite> object_2D = new List<Sprite>();

        //Player Raft
        public static Raft playerRaft;
        public static float raftTimer, raftTimerDelay;

        //Loot Tables
        public static SO_RandomDropper TestDropper, FishingRod_Dropper, FishingNet_Dropper;

        //FishingNetObject
        public static List<FishingNet> activeFishingNets = new List<FishingNet>();
        // public static Dictionary<Transform, MonoBehaviour> activeFishingNets = new Dictionary<Transform, MonoBehaviour>();

        //Game Managers
        public static Network_Player playerNetwork;
        public static ItemManager itemManager;
        public static ResourceManager resourceManager;
        public static List<Item_Base> usableItems;
        public static List<Item_Base> allItems;





        public async void Start()
        {
            harmonyInstance = new Harmony(harmonyID);
            harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());


            ComponentManager<Arashi_RaftFishingExpansion>.Value = this;

            var bundleLoadRequest = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("scrapmechanic_trophies.assets"));
            var bundleLoadRequest2 = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("chapter2hotfix.assets"));
            var bundleLoadRequest3 = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("fishingnet_hotfix.assets"));

            while (!bundleLoadRequest.isDone || !bundleLoadRequest2.isDone || !bundleLoadRequest3.isDone) { await Task.Delay(100); } //Prevents assigning ScrapMechanicTrohpies before asset bundle is loaded
            Debug.Log("Arashi: Bundles Have Loaded.");
            ScrapMechanicTrophies = bundleLoadRequest.assetBundle;
            Chapter2HotFix = bundleLoadRequest2.assetBundle;
            FishingNetHotFix = bundleLoadRequest3.assetBundle;
            //	Debug.Log("Arashi: Attempting To register scrap mechanic trohpies");
            RegisterScrapMechanicTrophies();
            //  Debug.Log("Arashi: Attempting To register fishingnets");
            RegisterFishingNets();
            //  Debug.Log("Arashi: Attempting To register chapter2hotfix");
            RegisterHotFix();
            Debug.Log("Arashi: all section's registered.");


        }




        public override void WorldEvent_WorldLoaded()
        {
            if (playerNetwork == null) { playerNetwork = RAPI.GetLocalPlayer(); }
            playerRaft = ComponentManager<Raft>.Value;
            Debug.Log("The world is loaded!");
            //    InitializeEventTimer();
            var arashiEventTimer = new EventTimer();
            arashiEventTimer.Start();
        }

        public override void WorldEvent_WorldUnloaded()
        {
            activeFishingNets.Clear();
        }


            // The Update() method is being called every frame. Have fun!
            public void Update()
        {
        }

        #region Asset Bundle Managment

        public static async Task<object> GetAssetFromTargetBundle(AssetBundle sourceBundle, string name)
        {
            AssetBundleRequest requestedAsset = sourceBundle.LoadAssetAsync(name);
            while (!requestedAsset.isDone) { await Task.Delay(1); } //ensures asset is not returned until it is ready
            return requestedAsset.asset;
        }


       

        #endregion



        #region ScrapMechanicTrophies

        public async void RegisterScrapMechanicTrophies()
        {
            //Register new items
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_CraftBot"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_BananaCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_BlueBerryCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_BroccoliCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_Bucket"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_CarrotCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_CookBot"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_CowCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_GlowGorp"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_OrangeCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_PineappleCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_RedBeetCrate"), StandardQuadType);
            RaftModder.RegisterPlaceableItem((Item_Base)await GetAssetFromTargetBundle(ScrapMechanicTrophies, "Placeable_ScrapMechanicTrophy_TomatoCrate"), StandardQuadType);
        }



        [HarmonyPatch(typeof(FishingBaitHandler)), HarmonyPatch("GetRandomItemFromCurrentBaitPool")]
        public class FishingRodDropperPatch
        {
            private static void Postfix(ref Item_Base __result)
            {
                if (__result != null)
                {
                    Network_Player player = RAPI.GetLocalPlayer();
                    Item_Base currentItemInHand = player.PlayerItemManager.useItemController.GetCurrentItemInHand();

                    System.Random rand = new System.Random();
                    string oldItem = __result.UniqueName;
                    if (oldItem == "Placeable_ScrapMechanic" || oldItem == "Placeable_LuckyCat" || oldItem == "Placeable_Cropplot_Shoe" || oldItem == "Placeable_GlassCandle")
                    {
                        Debug.Log("Item Randomizer Activated!");
                        if (currentItemInHand.UniqueName == "FishingRod" && rand.Next(0, 10) > 7) { __result = FishingRod_Dropper.GetRandomItem(); }
                        else if (currentItemInHand.UniqueName == "FishingRod_Metal" && rand.Next(0, 10) < 8) { __result = FishingRod_Dropper.GetRandomItem(); }
                    }
                }
            }
        }




        #endregion


        #region FishingNets


        public async void RegisterHotFix()
        {
            Debug.Log("Attempting To RegisterHotFix()");
            FishingNet_Dropper = (SO_RandomDropper)await GetAssetFromTargetBundle(Chapter2HotFix, "Dropper_FishingNet");
            FishingRod_Dropper = (SO_RandomDropper)await GetAssetFromTargetBundle(Chapter2HotFix, "Dropper_Arashi_ScrapTrophies");
        }
        #endregion





        #region FishingNets

        public Component[] masterFish;

        public async void RegisterFishingNets()
        {
           
            Debug.Log("Attempting To RegisterFishingNets()");

            CostMultiple _CraftingCost1, _CraftingCost2, _CraftingCost3; //Temporary placeholders for setting recipes
            CostMultiple[] _CraftingCost;
            string _Description;

            GameObject fishingNetObject = (GameObject)await GetAssetFromTargetBundle(FishingNetHotFix, "Placeable_FishingNet");
            _Description = "A makeshift fishing net created from an item collection net";
            _CraftingCost1 = new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Placeable_CollectionNet_Basic") /*, ItemManager.GetItemByName("Raw_Catfish")*/ }, 1);
            _CraftingCost2 = new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Rope") }, 3);
            _CraftingCost3 = new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Plank") }, 3);
            _CraftingCost = new CostMultiple[] { _CraftingCost1, _CraftingCost2, _CraftingCost3 };

            Item_Base fishingNetItem = RaftModder.createItemBase(ItemManager.GetItemByName("Placeable_CollectionNet_Basic"),730,"Placeable_FishingNet",fishingNetObject, "Fishing Net",_Description, 5);
			
			fishingNetItem.settings_Inventory.LocalizationTerm = ""; //LocalizationTerm Must be cleard so language changes do not effect the item info
			//fishingNetItem.settings_Inventory.DisplayName = "Fishing Net";
			//fishingNetItem.settings_Inventory.Description = "A Lure Net to Catch Fish On an Moving Raft";
			
			//fishingNetItem.settings_Inventory.Sprite.color = new color (0,1,1);


   //step2: Set new recipe
            RaftModder.SetRecipe(fishingNetItem, _CraftingCost,CraftingCategory.Other, 1, true);
  

  //Step3: add scripts to gameobject         
  
            GameObject fishNet = fishingNetItem.settings_buildable.GetBlockPrefab(0).gameObject;
			
        
            fishNet.AddComponent<FishingNet>();

            masterFish = fishNet.GetComponentsInChildren(typeof(Animation)); //find the masterfish by their Animation component
            

            foreach (Animation fish in masterFish)
            {
                Arashi.objectEnabler _enabler = fish.gameObject.AddComponent<Arashi.objectEnabler>();//add the object_enabler component to each masterFish
                _enabler.objectModel.Add(_enabler.transform.Find("Live_Catfish").gameObject);
                _enabler.objectModel.Add(_enabler.transform.Find("Live_Herring").gameObject);
                _enabler.objectModel.Add(_enabler.transform.Find("Live_Mackerel").gameObject);
                _enabler.objectModel.Add(_enabler.transform.Find("Live_Pomfret").gameObject);
                _enabler.objectModel.Add(_enabler.transform.Find("Live_Salmon").gameObject);
                _enabler.objectModel.Add(_enabler.transform.Find("Live_Tilapia").gameObject);
                _enabler.objectItem.Add("Raw_Catfish");
                _enabler.objectItem.Add("Raw_Herring");
                _enabler.objectItem.Add("Raw_Mackerel");
                _enabler.objectItem.Add("Raw_Pomfret");
                _enabler.objectItem.Add("Raw_Salmon");
                _enabler.objectItem.Add("Raw_Tilapia");
            }
           // Debug.Log("FishModels Found! : " + DateTime.Now);
            RaftModder.RegisterPlaceableItem(fishingNetItem, FoundationQuadType);

        }
        #endregion




    }

    #region Mod Utility Scripts

    public class RaftModder
    {

        //Set the recipe for the selected item 

        public static void SetRecipe(Item_Base item, CostMultiple[] cost, CraftingCategory category = CraftingCategory.Resources, int amountToCraft = 1, bool learnedFromBeginning = false)
        {
            Traverse recipe = Traverse.Create(item.settings_recipe);
            recipe.Field("craftingCategory").SetValue(category);
            recipe.Field("amountToCraft").SetValue(amountToCraft);
            recipe.Field("learnedFromBeginning").SetValue(learnedFromBeginning);
            item.settings_recipe.NewCost = cost;
        }

        public static Item_Base createItemBase(Item_Base templateItem, int uniqueIndex, string uniqueName, GameObject _gameObject, string _DisplayName, string _Description, int _stackSize)
        {
           
            Item_Base newItem = ScriptableObject.CreateInstance<Item_Base>();
            
            newItem.Initialize(uniqueIndex, uniqueName, templateItem.MaxUses);


            newItem.settings_buildable = templateItem.settings_buildable.Clone(); 
            Traverse buildSettings = Traverse.Create(newItem.settings_buildable);
            buildSettings.Field("blockPrefabs").SetValue(new Block[] { _gameObject.GetComponent<Block>() } );



            newItem.settings_consumeable = templateItem.settings_consumeable.Clone();
            newItem.settings_cookable = templateItem.settings_cookable.Clone();
            newItem.settings_equipment = templateItem.settings_equipment.Clone();


            newItem.settings_Inventory = templateItem.settings_Inventory.Clone();
            newItem.settings_Inventory.DisplayName = _DisplayName;
            newItem.settings_Inventory.Description = _Description;
            Traverse inventorySettings = Traverse.Create(newItem.settings_Inventory);
            buildSettings.Field("stackSize").SetValue(_stackSize);




            newItem.settings_recipe = templateItem.settings_recipe.Clone();
            newItem.settings_usable = templateItem.settings_usable.Clone();



            return newItem;


}

        public static SO_RandomDropper createRandomDropper()
        {
            return null;
        }

        public static void RegisterPlaceableItem(Item_Base item, RBlockQuadType[] quadtypes)
        {
            int currentMenuOffset = 1;
            int line = 1;

            //Traverse.Create(item.settings_recipe).Field("subCategory").SetValue(line.ToString()); //This line causes problems because of line to string it was "ItemNets"
			
			
			Traverse.Create(item.settings_recipe).Field("subCategory").SetValue("");
			
            if (currentMenuOffset == 4)
            {
                currentMenuOffset = 0;
                line++;
            }
            currentMenuOffset++;
            RAPI.RegisterItem(item);
            foreach (RBlockQuadType rb in quadtypes)
            {
                RAPI.AddItemToBlockQuadType(item, rb);
            }
        }

    }




    #endregion


    #region Fishingnet Block Classes

    public class FishingNet : MonoBehaviour, IRaycastable
    {

        internal bool initialized = false;

     

        internal Block fishingNet;

        internal Item_Base[] caughtFishItem = { null, null, null };
        internal Component[] fishAnimators, caughtFish;

       
        internal double timeTillCatch;
        internal int fishCount = 0;

        internal bool netFull = false;
        internal bool catchingFish = false;

        internal SO_RandomDropper Dropper;
      
        //Needed for OnIsRayed GUI
        private CanvasHelper canvas;
        private bool displayText;


        public void OnIsRayed()
        {
            if (MyInput.GetButtonDown("Interact"))
            {
                   Debug.Log("Clicked The FishingNet");
                CollectFish();
            }


            if (Helper.LocalPlayerIsWithinDistance(base.transform.position, Player.UseDistance) && fishCount > 0)
            {
                LocalizationParameters.itemCount = this.fishCount;
                this.canvas.displayTextManager.ShowText(Helper.GetTerm("Game/CollectItemCount", true), MyInput.Keybinds["Interact"].MainKey, 0, 0, true);
                this.displayText = true;
                return;
            }
            if (this.canvas != null)
            {
                this.canvas.displayTextManager.HideDisplayTexts();
            }
            this.displayText = false;


        }

        public void OnRayEnter()
        {
              //Debug.Log("Spotted The FishingNet");
        }

        public void OnRayExit()
        {
            //Debug.Log("Not Looking at The FishingNet");
            if (this.displayText)
            {
                this.canvas.displayTextManager.HideDisplayTexts();
                this.displayText = false;
            }
        }




        private void Start()
        {   
            Dropper = Arashi_RaftFishingExpansion.FishingNet_Dropper;
            this.canvas = ComponentManager<CanvasHelper>.Value;
        }




        private void OnBlockPlaced()
        {
            

            this.fishingNet = base.GetComponent<Block>();

            this.fishAnimators = fishingNet.GetComponentsInChildren(typeof(Animation));//Each Masterfish has an animation component

          this.caughtFish = fishingNet.GetComponentsInChildren(typeof(Arashi.objectEnabler));

            if (!Arashi_RaftFishingExpansion.activeFishingNets.Contains(this))//If the master list does not contain the current fishingNet then add it.
                Arashi_RaftFishingExpansion.activeFishingNets.Add(this);

            initialized = true;

        }


        void AnimateFish()
        {
            foreach (Animation fishAnimation in fishAnimators)
            {
                fishAnimation.Play();
            }

        }


        public void SpawnFish()
        {
            Debug.Log("Event:Catching Fish");
            int i = 0;
            foreach (Arashi.objectEnabler fishSlot in caughtFish)
            {
                if (caughtFishItem[0] == null && i == 0)
                {
                    caughtFishItem[i] = (Dropper.GetRandomItem());
                    fishSlot.ActivateModel(caughtFishItem[i]);
                        Debug.Log("Notice:Catching 1st Fish: a " + caughtFishItem[i].UniqueName);
                    fishCount++;
                    break;

                }
                else if (caughtFishItem[1] == null && i == 1)
                {
                    caughtFishItem[i] = (Dropper.GetRandomItem());
                    fishSlot.ActivateModel(caughtFishItem[i]);
                        Debug.Log("Notice:Catching 2nd Fish: a " + caughtFishItem[i].UniqueName);
                    fishCount++;
                    break;
                }
                else if (caughtFishItem[2] == null && i == 2)
                {
                    caughtFishItem[i] = (Dropper.GetRandomItem());
                    fishSlot.ActivateModel(caughtFishItem[i]);
                    netFull = true;
                        Debug.Log("Notice:Caught Final Fish : a " + caughtFishItem[i].UniqueName + "- The Fishing Net is now Full");
                    fishCount++;

                }
                i++;
            }
            //AnimateFish(); //not needed, fish are animated on enable.
        }

        public void setTimeTillCatch(double _TimeDelay)
        {
            timeTillCatch = _TimeDelay;
        }

        void CollectFish()
        {
           // Debug.Log("Event:Collecting Fish");
            int i = 0;
            foreach (Arashi.objectEnabler fishSlot in caughtFish)
            {
                fishSlot.DisableModels();
                if (caughtFishItem[i] != null) { RAPI.GiveItem(caughtFishItem[i], 1); }
                caughtFishItem[i] = null;
                i++;
            }
            fishCount=0;
            this.netFull = false;
        }


    }



    public class objectEnabler : MonoBehaviour
    {
        [SerializeField]
        public List<GameObject> objectModel = new List<GameObject>();


        [SerializeField]
        public List<string> objectItem = new List<string>();

        internal Component[] transforms;

        

        public void DisableModels()
        {
            foreach (GameObject model in objectModel) { model.SetActive(false); }
        }

        public void ActivateModel(Item_Base targetItem)
        {
            DisableModels();//redudent disable possibly not needed.
            int counter = 0;
            foreach (string item in objectItem)
            {
                if (targetItem.UniqueName == objectItem[counter]) { objectModel[counter].SetActive(true); return; }
                    counter++;
            }


        }


    }


    #endregion


    

    public class EventTimer
    {
        private float StartTime;
        private float LastTime;
        private float elapsedTime;
        private bool initialized = false;
        private int checkDelay=60000;
        internal System.Random _Random;
        internal int timeDelayMin = 3, timeDelayMax = 12; //random delay between in minutes (note: variable is multiplied by 60 later on to give distinct differences to random time)

        public void Start()
        {
            _Random = new System.Random();
            InitializeFishingNets();
            StartTimer();
        }

        public async void StartTimer()
        {
            while (!initialized) {await Task.Delay(1000); }
            StartTime = Time.time;
            await Task.Delay(checkDelay);
            RunUpdate();
        }

        public void RunUpdate()//Things to be processed during custom update process.
        {
            Debug.Log("Timer Update activate the time is :" + DateTime.Now);
            ProcessFishingNets();
            StartTimer();//Restarts the timer process.
        }


        public double GetElapsedTime()
        {
            elapsedTime = Time.time - StartTime;
            Debug.Log("Elapsed Time is since last Fishing Timer update : " + elapsedTime);
            return elapsedTime;
        }


        public async void InitializeFishingNets()
        {
            await Task.Delay(5000);
            Debug.Log("Found " + Arashi_RaftFishingExpansion.activeFishingNets.Count + " active Fishing Nets : Initializing...");

            foreach (FishingNet _FishingNet in Arashi_RaftFishingExpansion.activeFishingNets)
                {   
                _FishingNet.timeTillCatch = _Random.Next(timeDelayMin, timeDelayMax) * 60;
                Debug.Log("Timer Set for " + _FishingNet.timeTillCatch + " Seconds");
                await Task.Delay(120);
                }
            Debug.Log("All FishingNets Initialized");
            initialized = true;
        }

        public async void ProcessFishingNets()
        {
            double _ElapsedTime = GetElapsedTime();
            StartTime = Time.time;

            

            for(int i = Arashi_RaftFishingExpansion.activeFishingNets.Count-1; i >-1; i--)//Manual reverse iteration of loop did not cause any errors while removing variable.
            {
                if (!Arashi_RaftFishingExpansion.playerRaft.Moving) { return; }
               
               if (Arashi_RaftFishingExpansion.activeFishingNets[i] == null)
                   {
                   Debug.Log("Fishing Net is missing from raft, Removing Net from list.");
                  Arashi_RaftFishingExpansion.activeFishingNets.RemoveAt(i);//for this removal to itterate correctly we needed the reverse list.
                    //Debug.Log("Attempting loop Continue.");
                    continue;
                }
                
                if (!Arashi_RaftFishingExpansion.activeFishingNets[i].netFull)//This will only run if a gameobject was found for the item in the list.
                {
                    if (Arashi_RaftFishingExpansion.activeFishingNets[i].timeTillCatch > 0) //if there is time left in the fishing net then subtract the difference in time since last check.
                    {
                        Arashi_RaftFishingExpansion.activeFishingNets[i].setTimeTillCatch(Arashi_RaftFishingExpansion.activeFishingNets[i].timeTillCatch - _ElapsedTime);
                          // Debug.Log("Time left : " + Arashi_RaftFishingExpansion.activeFishingNets[i].timeTillCatch + " Seconds");
                    }
                    if (Arashi_RaftFishingExpansion.activeFishingNets[i].timeTillCatch <= 0) //If the fishingnet is out of time then process catch.
                    {
                        if (Arashi_RaftFishingExpansion.activeFishingNets[i].netFull) { return; }
                        Arashi_RaftFishingExpansion.activeFishingNets[i].SpawnFish();//Spawn a fish into the net
                        Arashi_RaftFishingExpansion.activeFishingNets[i].timeTillCatch = _Random.Next(timeDelayMin, timeDelayMax) * 60;//Reset the catch delay by a random time
                         //   Debug.Log("Timer Set for " + Arashi_RaftFishingExpansion.activeFishingNets[i].timeTillCatch + " Seconds") ;
                    }
                }
                await Task.Delay(60);
            }
        }

    }

}
